type conditional_expression =
    | Var of string
    | True
    | False
    | Or of conditional_expression * conditional_expression
    | And of conditional_expression * conditional_expression

let rec as_string = function
  | Var x -> x
  | True -> "true"
  | False -> "false"
  | Or (l, r) -> apply "\\/" l r
  | And (l, r) -> apply "/\\" l r

and apply op l r = 
  "(" ^ as_string l ^ " " ^ op ^ " " ^ as_string r ^ ")"
